Scala Standard Library2.13.5 < Back


# Packages

-  package root

  This is the documentation for the Scala standard library.

  This is the documentation for the Scala standard library.

  #### Package structure

  The scala package contains core types like `Int`, `Float`, `Array` or `Option` which are accessible in all Scala compilation units without explicit qualification or imports.

  Notable packages include:

  - `scala.collection` and its sub-packages contain Scala's collections framework
    - `scala.collection.immutable` - Immutable, sequential data-structures such as `Vector`, `List`, `Range`, `HashMap` or `HashSet`
    - `scala.collection.mutable` - Mutable, sequential data-structures such as `ArrayBuffer`, `StringBuilder`, `HashMap` or `HashSet`
    - `scala.collection.concurrent` - Mutable, concurrent data-structures such as `TrieMap`
  - `scala.concurrent` - Primitives for concurrent programming such as `Futures` and `Promises`
  - `scala.io` - Input and output operations
  - `scala.math` - Basic math functions and additional numeric types like `BigInt` and `BigDecimal`
  - `scala.sys` - Interaction with other processes and the operating system
  - `scala.util.matching` - Regular expressions

  Other packages exist. See the complete list on the right.

  Additional parts of the standard library are shipped as separate libraries. These include:

  - `scala.reflect` - Scala's reflection API (scala-reflect.jar)
  - `scala.xml` - XML parsing, manipulation, and serialization (scala-xml.jar)
  - `scala.collection.parallel` - Parallel collections (scala-parallel-collections.jar)
  - `scala.util.parsing` - Parser combinators (scala-parser-combinators.jar)
  - `scala.swing` - A convenient wrapper around Java's GUI framework called Swing (scala-swing.jar)

  #### Automatic imports

  Identifiers in the scala package and the `scala.Predef` object are always in scope by default.

  Some of these identifiers are type aliases provided as shortcuts to commonly used classes. For example, `List` is an alias for `scala.collection.immutable.List`.

  Other aliases refer to classes provided by the underlying platform. For example, on the JVM, `String` is an alias for `java.lang.String`.

  Definition Classes
    root
-  package scala

  Core Scala types.

  Core Scala types. They are always available without an explicit import.

  Definition Classes
    root
-  package reflect
  Definition Classes
    scala
- AnyValManifest
- ClassManifestDeprecatedApis
- ClassManifestFactory
- ClassTag
- Manifest
- ManifestFactory
- NameTransformer
- NoManifest
- OptManifest

c

scala.reflect

# AnyValManifest

###

#### abstract class AnyValManifest[T <: AnyVal] extends Manifest[T] with Equals

Annotations
  @nowarn() @SerialVersionUID()
Source
  Manifest.scala

Linear Supertypes
Manifest[T], ClassTag[T], Equals, ClassManifestDeprecatedApis[T], OptManifest[T], java.io.Serializable, AnyRef, Any
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. AnyValManifest
2. Manifest
3. ClassTag
4. Equals
5. ClassManifestDeprecatedApis
6. OptManifest
7. Serializable
8. AnyRef
9. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Instance Constructors

1.  new AnyValManifest(toString: String)

### Abstract Value Members

1.  abstract def runtimeClass: Class[_]

   A class representing the type `U` to which `T` would be erased.

   A class representing the type `U` to which `T` would be erased. Note that there is no subtyping relationship between `T` and `U`.

   Definition Classes
     ClassTag

### Concrete Value Members

1.  final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any
2.  final def ##: Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from AnyValManifest[T] toany2stringadd[AnyValManifest[T]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (AnyValManifest[T], B)
   Implicit
     This member is added by an implicit conversion from AnyValManifest[T] toArrowAssoc[AnyValManifest[T]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  def <:<(that: ClassManifest[_]): Boolean

   Tests whether the type represented by this manifest is a subtype of the type represented by `that` manifest, subject to the limitations described in the header.

   Tests whether the type represented by this manifest is a subtype of the type represented by `that` manifest, subject to the limitations described in the header.

   Definition Classes
     AnyValManifest → ClassManifestDeprecatedApis
6.  final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any
7.  def argString: String
   Attributes
     protected
   Definition Classes
     ClassManifestDeprecatedApis
8.  def arrayClass[A](tp: Class[_]): Class[Array[A]]
   Attributes
     protected
   Definition Classes
     ClassManifestDeprecatedApis
9.  def arrayManifest: Manifest[Array[T]]
   Definition Classes
     Manifest → ClassManifestDeprecatedApis
10.  final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

11.  def canEqual(other: Any): Boolean

    A method that should be called from every well-designed equals method that is open to be overridden in a subclass.

    A method that should be called from every well-designed equals method that is open to be overridden in a subclass. See Programming in Scala, Chapter 28 for discussion and design.

    returns

      true if this instance can possibly equal `that`, otherwise false

    Definition Classes
      AnyValManifest → Manifest → ClassTag → Equals → ClassManifestDeprecatedApis
12.  def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.CloneNotSupportedException]) @native()
    Note

      not specified by SLS as a member of AnyRef

13.  def ensuring(cond: (AnyValManifest[T]) => Boolean, msg: => Any): AnyValManifest[T]
    Implicit
      This member is added by an implicit conversion from AnyValManifest[T] toEnsuring[AnyValManifest[T]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
14.  def ensuring(cond: (AnyValManifest[T]) => Boolean): AnyValManifest[T]
    Implicit
      This member is added by an implicit conversion from AnyValManifest[T] toEnsuring[AnyValManifest[T]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  def ensuring(cond: Boolean, msg: => Any): AnyValManifest[T]
    Implicit
      This member is added by an implicit conversion from AnyValManifest[T] toEnsuring[AnyValManifest[T]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
16.  def ensuring(cond: Boolean): AnyValManifest[T]
    Implicit
      This member is added by an implicit conversion from AnyValManifest[T] toEnsuring[AnyValManifest[T]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
17.  final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
18.  def equals(that: Any): Boolean

    Note: testing for erasure here is important, as it is many times faster than <:< and rules out most comparisons.

    Note: testing for erasure here is important, as it is many times faster than <:< and rules out most comparisons.

    Definition Classes
      AnyValManifest → Manifest → ClassTag → Equals → AnyRef → Any
19.  def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
    Note

      not specified by SLS as a member of AnyRef

20.  def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit
      This member is added by an implicit conversion from AnyValManifest[T] toStringFormat[AnyValManifest[T]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
21.  final def getClass(): Class[_ <: AnyRef]

    Returns the runtime class representation of the object.

    Returns the runtime class representation of the object.

    returns

      a class object corresponding to the runtime type of the receiver.

    Definition Classes
      AnyRef → Any
    Annotations
      @native()
22.  val hashCode: Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

23.  final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any
24.  final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
25.  def newArray(len: Int): Array[T]

    Produces a new array with element type `T` and length `len`

    Produces a new array with element type `T` and length `len`

    Definition Classes
      ClassTag
26.  final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @native()
    Note

      not specified by SLS as a member of AnyRef

27.  final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @native()
    Note

      not specified by SLS as a member of AnyRef

28.  final def synchronized[T0](arg0: => T0): T0

    Executes the code in `body` with an exclusive lock on `this`.

    Executes the code in `body` with an exclusive lock on `this`.

    returns

      the result of `body`

    Definition Classes
      AnyRef
29.  val toString: String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyValManifest → ClassTag → AnyRef → Any
30.  def typeArguments: List[Manifest[_]]
    Definition Classes
      Manifest → ClassManifestDeprecatedApis
31.  def unapply(x: Any): Option[T]

    A ClassTag[T] can serve as an extractor that matches only objects of type T.

    A ClassTag[T] can serve as an extractor that matches only objects of type T.

    The compiler tries to turn unchecked type tests in pattern matches into checked ones by wrapping a `(_: T)` type pattern as `ct(_: T)`, where `ct` is the `ClassTag[T]` instance. Type tests necessary before calling other extractors are treated similarly. `SomeExtractor(...)` is turned into `ct(SomeExtractor(...))` if `T` in `SomeExtractor.unapply(x: T)` is uncheckable, but we have an instance of `ClassTag[T]`.

    Definition Classes
      ClassTag
32.  final def wait(): Unit

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait--.

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait--.

    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
    Note

      not specified by SLS as a member of AnyRef

33.  final def wait(arg0: Long, arg1: Int): Unit

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-int-

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-int-

    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
    Note

      not specified by SLS as a member of AnyRef

34.  final def wait(arg0: Long): Unit

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-.

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-.

    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()
    Note

      not specified by SLS as a member of AnyRef

35.  def wrap: ClassTag[Array[T]]

    Produces a `ClassTag` that knows how to instantiate an `Array[Array[T]]`

    Produces a `ClassTag` that knows how to instantiate an `Array[Array[T]]`

    Definition Classes
      ClassTag

### Deprecated Value Members

1.  def >:>(that: ClassManifest[_]): Boolean

   Tests whether the type represented by this manifest is a supertype of the type represented by `that` manifest, subject to the limitations described in the header.

   Tests whether the type represented by this manifest is a supertype of the type represented by `that` manifest, subject to the limitations described in the header.

   Definition Classes
     ClassManifestDeprecatedApis
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) use scala.reflect.runtime.universe.TypeTag for subtype checking instead

2.  def erasure: Class[_]
   Definition Classes
     ClassManifestDeprecatedApis
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) use runtimeClass instead

3.  def newArray2(len: Int): Array[Array[T]]
   Definition Classes
     ClassManifestDeprecatedApis
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) use wrap.newArray instead

4.  def newArray3(len: Int): Array[Array[Array[T]]]
   Definition Classes
     ClassManifestDeprecatedApis
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) use wrap.wrap.newArray instead

5.  def newArray4(len: Int): Array[Array[Array[Array[T]]]]
   Definition Classes
     ClassManifestDeprecatedApis
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) use wrap.wrap.wrap.newArray instead

6.  def newArray5(len: Int): Array[Array[Array[Array[Array[T]]]]]
   Definition Classes
     ClassManifestDeprecatedApis
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) use wrap.wrap.wrap.wrap.newArray instead

7.  def newArrayBuilder(): ArrayBuilder[T]
   Definition Classes
     ClassManifestDeprecatedApis
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) use ArrayBuilder.make(this) instead

8.  def newWrappedArray(len: Int): ArraySeq[T]
   Definition Classes
     ClassManifestDeprecatedApis
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) create WrappedArray directly instead

9.  def →[B](y: B): (AnyValManifest[T], B)
   Implicit
     This member is added by an implicit conversion from AnyValManifest[T] toArrowAssoc[AnyValManifest[T]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from Manifest[T]

### Inherited from ClassTag[T]

### Inherited from Equals

### Inherited from ClassManifestDeprecatedApis[T]

### Inherited from OptManifest[T]

### Inherited from java.io.Serializable

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromAnyValManifest[T] to any2stringadd[AnyValManifest[T]]

### Inherited by implicit conversion StringFormat fromAnyValManifest[T] to StringFormat[AnyValManifest[T]]

### Inherited by implicit conversion Ensuring fromAnyValManifest[T] to Ensuring[AnyValManifest[T]]

### Inherited by implicit conversion ArrowAssoc fromAnyValManifest[T] to ArrowAssoc[AnyValManifest[T]]

### Ungrouped